# Solace PubSub+ Connector for TIBCO EMS: Java dependencies in the `/libs` folder
Solace
Corporation https://solace.com

*Revision: 2.0.0*
<br/>*Revision Date: 2023-11-30*

## Table of Contents

-   [Preface]
-   [TIBCO EMS Jakarta Messaging Library]
-   [Micrometer Metrics exporter dependencies]

## Preface

This `/libs` folder is provided as a default location for the Java library dependencies (external `jar` files) that are either required or required only when using certain features of the Connector (such as Prometheus libraries when using the metrics export to Prometheus feature in your Connector configuration).

These \`jar\`s are not provided by Solace due to licensing and/or size considerations and need to be provided as part of the deployment of a Connector in order for the Connector to operate correctly.

## TIBCO EMS Jakarta Messaging Library

The Connector uses the TIBCO EMS Jakarta Messaging library to provide connection and message processing to TIBCO EMS servers.

The TIBCO EMS Jakarta Messaging library can be downloaded from the official TIBCO website or from a TIBCO EMS server install provided by TIBCO. Once obtained, the library needs to be placed in the `libs` folder for the connector to operate correctly.

Version 2.0.0 of the Connector has been mostly developed and tested using version `10.2.1` of the `jakarta.jms-tibjms.jar` library.

## Micrometer Metrics exporter dependencies

The Connector makes use of [Micrometer.io] to provide easy, configuration-driven exporting of Connector metrics to many 3rd-party metrics monitoring solutions (see the full list on the Micrometer site).

These services can be configured in the Connector configuration (there are commented hints in the sample configuration provided) but must have the necessary Java dependencies in the `/libs` folder to operate.

Which jars are necessary will depend on which metrics service you are configuring. The details for each provider can be found in the [Micrometer documentation] For example, for [Datadog], the Micrometer instructions list `io.micrometer.micrometer-registry-datadog` as the main client library needed and the Maven Central page for this library provides download links for the main `jar` and its compile dependencies. These jar’s would be placed in the Connector `/libs` folder.

  [Preface]: #preface
  [TIBCO EMS Jakarta Messaging Library]: #tibco-ems-jakarta-messaging-library
  [Micrometer Metrics exporter dependencies]: #micrometer-metrics-exporter-dependencies
  [Micrometer.io]: https://micrometer.io/
  [Micrometer documentation]:
  [Datadog]: https://www.datadoghq.com/
